'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function readCookie(key) {
    var regex = new RegExp('(?:^|; )' + encodeURIComponent(key) + '=([^;]*)');
    var result = regex.exec(document.cookie);

    return result ? result[1] : null;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function homegearRandomUserName() {
    var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var id = 'ui';

    for (var i = 0; i < 8; i++) {
        id += possible.charAt(Math.floor(Math.random() * possible.length));
    }return id;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function homegear_new() {
    return new (Function.prototype.bind.apply(HomegearWS, [null].concat([interfaceData.options.websocket_url == 'location.hostname' ? location.hostname : interfaceData.options.websocket_url, interfaceData.options.websocket_port == 'location.port' ? location.port : Number(interfaceData.options.websocket_port), homegearRandomUserName(), location.protocol == 'https:'], Array.prototype.slice.call(arguments))))();
}

if (interfaceData.options.websocket_security_ssl === false && location.protocol == 'http:') interfaceData.options.websocket_security_ssl = false;

var homegear = homegear_new(readCookie('PHPSESSIDUI'));

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.ready(function () {
    var addDevicesAsHomegearPeers = Object.keys(interfaceData.map_invoke).map(Number);

    console.log('HomegearPeers: ');
    console.log(addDevicesAsHomegearPeers);

    homegear.addPeers(addDevicesAsHomegearPeers);
    $('#loadingPage').hide();
});

homegear.connected(function () {});

homegear.disconnected(function () {
    $('#loadingPage').show();
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//get new sessionid when websocket reconnects
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.reconnected(function () {
    window.location.reload(true);
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//print Homegear errors
////////////////////////////////////////////////////////////////////////////////////////////////////////
homegear.error(function (message) {
    console.log(message);
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
if (location.protocol == 'http:' && interfaceData.options.websocket_security_ssl === true) console.log('Homegear security issue!');else homegear.connect();

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function handle_homegear_update(resp) {
    // DEBUG: works as expected
    var peer = resp.params[1],
        channel = resp.params[2],
        name = resp.params[3];
    var value = resp.params[4];

    if (!(peer in interfaceData.map_invoke && channel in interfaceData.map_invoke[peer] && name in interfaceData.map_invoke[peer][channel])) return;

    var inputs = interfaceData.map_invoke[peer][channel][name];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = inputs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var input = _step.value;

            if (!(input.databaseId in interfaceData.devices && input.control in interfaceData.devices[input.databaseId].controls && input.input in interfaceData.devices[input.databaseId].controls[input.control].variableInputs)) continue;

            //Does it improve reaction time to run the loop twice (does the "emit" hang shortly)? If not, only run it once.
            var invert = false;
            for (var roleIndex in input.roles) {
                var role = input.roles[roleIndex];
                if (!role.hasOwnProperty('id')) continue;else if (role.hasOwnProperty('direction') && role.direction == 1) continue;

                if (role.hasOwnProperty('invert')) {
                    value = !value;
                    break; //Only invert once
                }
            }

            interfaceData.devices[input.databaseId].controls[input.control].variableInputs[input.input].properties.value = value;

            for (var _roleIndex in input.roles) {
                var _role = input.roles[_roleIndex];
                if (!_role.hasOwnProperty('id')) continue;else if (_role.hasOwnProperty('direction') && _role.direction == 1) continue;
                app.$root.$emit('role-update', _role.id);
            }
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Extensions to the homegear object
////////////////////////////////////////////////////////////////////////////////////////////////////////
function params_create(input, value) {
    if ('value' in input) {
        value = input.value;
    }
    return [Number(input.peer), Number(input.channel), input.name, value, false];
}

function homegear_prepare(homegear) {
    homegear.event(function (x) {
        return console.log(JSON.stringify(x, null, 4));
    });
    homegear.event(handle_homegear_update);

    homegear.invoke_multi = function (ops) {
        var object = {
            jsonrpc: '2.0',
            method: 'system.multicall',
            params: ops
        };

        console.log(JSON.stringify(object, null, 4));

        return this.invoke(object);
    };

    homegear.value_set_multi = function (ops) {
        return this.invoke_multi([ops.map(function (op) {
            return {
                methodName: 'setValue',
                params: params_create(op.input, op.value)
            };
        })]);
    };

    homegear.value_set_clickcounter = function (control, params, value) {
        var methods = [[{
            methodName: 'setValue',
            params: params_create(params, value)
        }]];

        if (Date.now() - control.lastClickCount > 10000) {
            control.lastClickCount = Date.now();
            methods[0].push({
                methodName: 'setUserData',
                params: ['ui.clickCounts', control.uiElement.databaseId.toString(), ++control.uiElement.clickCount]
            });
        }

        return this.invoke_multi(methods);
    };
}
homegear_prepare(homegear);

////////////////////////////////////////////////////////////////////////////////////////////////////////
// globale Variablen
////////////////////////////////////////////////////////////////////////////////////////////////////////
var controlComponents = {};
var logFrontend = '';
////////////////////////////////////////////////////////////////////////////////////////////////////////
// write console logs to setting/about/nameClick/log page
////////////////////////////////////////////////////////////////////////////////////////////////////////
if (typeof interfaceData.options.consoleLog !== 'undefined' && (interfaceData.options.consoleLog == 'true' || interfaceData.options.consoleLog == true)) {
    console.oldLog = console.log;
    console.log = function (value) {
        console.oldLog(value);
        viewLog(value);
    };

    console.oldWarn = console.warn;
    console.warn = function (value) {
        console.oldWarn(value);
        viewLog(value);
    };

    console.oldError = console.error;
    console.error = function (value) {
        console.oldError(value);
        viewLog(value);
    };

    console.oldInfo = console.info;
    console.info = function (value) {
        console.oldInfo(value);
        viewLog(value);
    };
} else {
    console.oldLog = console.log;
    console.log = function () {};
}

function viewLog(value) {
    if (value !== null && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') value = JSON.stringify(value);

    logFrontend += value + '<br/>';

    if ($('#log').length) {
        $('#log').html(logFrontend);
        $('#log').scrollTop(9999999999);
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// isJSON
////////////////////////////////////////////////////////////////////////////////////////////////////////
function isJSON(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
$('#' + interfaceData.options.breadcrumbs_id_array[0]).addClass('content_single');
$('.breadcrumbsJump').html(interfaceData.options.firstBreadcrumb);

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verhindert das die Zurück Funktion bei DesktopBrowsern ausgeführt werden kann
////////////////////////////////////////////////////////////////////////////////////////////////////////
location.hash = 'nb';
$(window).on('hashchange', function () {
    content('back', { back: '1' });
    location.hash = 'nb';
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verhindert, dass der PullFromTopToRefresh im Android Chrome Browser ausgeführt werden kann
////////////////////////////////////////////////////////////////////////////////////////////////////////
var lastTouchY = 0;
var preventPullToRefresh = false;

$('body').on('touchstart', function (e) {
    if (e.originalEvent.touches.length != 1) return;

    lastTouchY = e.originalEvent.touches[0].clientY;
    preventPullToRefresh = window.pageYOffset == 0;
});

$('body').on('touchmove', function (e) {
    var touchY = e.originalEvent.touches[0].clientY;
    var touchYDelta = touchY - lastTouchY;

    lastTouchY = touchY;
    if (preventPullToRefresh) {
        preventPullToRefresh = false;
        if (touchYDelta > 0) {
            e.preventDefault();
            return;
        }
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// passt die Header Tab Anzeige beim scrollen an
////////////////////////////////////////////////////////////////////////////////////////////////////////
headerVisibility('true');
function headerVisibility(state) {
    var stateDownScroll = state === 'true' ? 'block' : 'none';
    var stateUpScroll = 'block';
    var lastScrollTop = 0;

    $('.content').scroll(function (event) {
        var st = $(this).scrollTop();

        if (st > lastScrollTop) {
            // downscroll code
            $('.content_single #tabs').hide();
            $('.content_big #tabs').hide();
        } else {
            // upscroll code
            $('.content_single #tabs').show();
            $('.content_big #tabs').show();
        }
        lastScrollTop = st;
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// ermoeglicht die gesamte Navigationslogik
// Über ein Array wird zwischen den Ebenen gesprungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function content_delete_breadcumb_container(ids, vals) {
    $('#' + ids[ids.length - 1]).remove();
    vals.pop();
    ids.pop();
}

function content_hndl_breadcrumb_classes(ids, destSize) {
    if (ids.length > 1) {
        $('#' + ids[ids.length - 1]).addClass(destSize);
        $('#' + ids[ids.length - 2]).addClass('content_small');
    } else if (interfaceData.options.breadcrumbs_id_array.length == 1) {
        $('#' + ids[ids.length - 1]).addClass('content_single');
        $('#back').addClass('inactive');
    } else $('#back').addClass('inactive');
}

function content(element, options) {
    var destSize = 'content_big';

    if ((typeof options === 'undefined' ? 'undefined' : _typeof(options)) != 'object') options = $.parseJSON(options);

    if ('back' in options && interfaceData.options.breadcrumbs_id_array.length <= 1) {
        $('#back').addClass('inactive');
        $('.content').scrollTop(0);
        return;
    }

    if ('existing' in options) var id = options.existing;

    if ('size' in options && options.size === 'mega_big') destSize = 'content_mega_big';

    if ('content' in options) {
        var id = '';
        var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

        for (var i = 0; i < 8; i++) {
            id += possible.charAt(Math.floor(Math.random() * possible.length));
        }if (options.vue) {
            $('#inhalt').append('<div id="' + id + '" class="content"></div>');
            var vueContent = app.$el.querySelector('#' + id);
            for (var _i in options.content) {
                vueContent.appendChild(options.content[_i]);
            }
        } else $('#inhalt').append('\n                <div id="' + id + '" class="content">\n                    ' + options['content'] + '\n                </div>\n            ');
    }

    $('.content_single').removeClass('content_single');
    $('.content_small').removeClass('content_small');
    $('.content_big').removeClass('content_big');
    $('.content_mega_big').removeClass('content_mega_big');
    $('.content_back').remove();

    if ('jump' in options) {
        for (var _i2 = interfaceData.options.breadcrumbs_id_array.length - options.jump; _i2 > 1; _i2--) {
            content_delete_breadcumb_container(interfaceData.options.breadcrumbs_id_array, interfaceData.options.breadcrumbs_array);
        }content_hndl_breadcrumb_classes(interfaceData.options.breadcrumbs_id_array, destSize);
    } else if ('back' in options) {
        //löschen des aktuellen containers
        content_delete_breadcumb_container(interfaceData.options.breadcrumbs_id_array, interfaceData.options.breadcrumbs_array);

        content_hndl_breadcrumb_classes(interfaceData.options.breadcrumbs_id_array, destSize);
    } else {
        interfaceData.options.breadcrumbs_array.push('\n            <div class="breadcrumbsJump"\n                 onclick=\'content(this, {"jump":"' + interfaceData.options.breadcrumbs_array.length + '"});\'>\n                ' + options.name + '\n            </div>\n        ');

        $('#' + id).addClass(destSize);
        $('#' + interfaceData.options.breadcrumbs_id_array[interfaceData.options.breadcrumbs_id_array.length - 1]).addClass('content_small');
        interfaceData.options.breadcrumbs_id_array.push(id);
        $('#back').removeClass('inactive');
    }

    $('.content_small').append('\n        <div class="content_back" onclick=\'content(this, {"back":"1"});\'>\n        </div>\n    ');

    var text = '';
    for (var _i3 = 0; _i3 < interfaceData.options.breadcrumbs_array.length; _i3++) {
        text += interfaceData.options.breadcrumbs_array[_i3];

        if (_i3 + 1 != interfaceData.options.breadcrumbs_array.length) text += '<div class="breadcrumbs_separator">|</div>';
    }

    document.getElementById('breadcrumbsSub').innerHTML = text;

    $('#breadcrumbsSub').scrollLeft(9999999999);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// triggert beim Logoff eines Users das Löschen des Cookies
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_logoff() {
    window.location.href = 'signin.php?logout=1';
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Tabs
////////////////////////////////////////////////////////////////////////////////////////////////////////
function showTab(element, tab) {
    // Aktiven Tab finden und deaktivieren
    $(element).parent().find('.active').removeClass('active');
    $(element).parent().find('.tab_pfeil').remove();

    // Angeklickten Tab aktivieren
    $(element).addClass('active');
    $(element).append('<div class="tab_pfeil"><svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0" y="0" width="200" height="100" viewBox="0, 0, 200, 100"><g id="Ebene_1"><path d="M0,-0 L204,-0 L101.747,100.002" /></g></svg></div>');

    // Content im aktiven Tab finden und deaktivieren
    $(element).parents('.content').find('.activeTab').removeClass('activeTab');

    // Content im angeklicktem Tab aktivieren
    $(element).parents('.content').find('.tabWrapper:eq(' + tab + ')').addClass('activeTab');

    $(element).parents('.content').scrollTop(0);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// License
////////////////////////////////////////////////////////////////////////////////////////////////////////
function license() {
    var table_rows = licenses.map(function (x) {
        return '\n        <tr>\n            <td>' + x.name + '</td>\n            <td>' + x.version + '</td>\n            <td>' + x.rights + '</td>\n            <td>' + x.licensename + '</td>\n            <td>' + x.licenseurl + '</td>\n        </tr>\n    ';
    }).join('\n');

    var data = '\n        <div class="table1">\n            <table>\n                <tr>\n                    <th onclick=\'content(this, {"name":"Log","content":"<div id=log>"+logFrontend+"</div>"})\'>\n                        ' + i18n('settings.about.table.name') + '\n                    </th>\n                    <th>' + i18n('settings.about.table.version') + '</th>\n                    <th>' + i18n('settings.about.table.rights') + '</th>\n                    <th>' + i18n('settings.about.table.license') + '</th>\n                    <th>' + i18n('settings.about.table.license.url') + '</th>\n                </tr>\n                ' + table_rows + '\n            </table>\n        </div>\n    ';

    content('this', { 'content': data, 'name': i18n('settings.about') });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function check_value_in_key(haystack, haystackkey, haystackneedle) {
    $.each(haystack, function (_, value) {
        if (value[haystackkey] === haystackneedle) {
            return true;
        }
    });

    return false;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function i18n(key) {
    var _arr = [interfaceData.i18n, interfaceData.i18n.default];

    for (var _i4 = 0; _i4 < _arr.length; _i4++) {
        var i = _arr[_i4];
        if (key in i) return i[key];else return '?';
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function condition_check(condition, value) {
    if (condition === null || condition === undefined) return true;

    switch (condition.operator) {
        case 'not':
            return value != condition.value;
        case 'e':
            return value == condition.value;
        case 'g':
            return value > condition.value;
        case 'l':
            return value < condition.value;
        case 'ge':
            return value >= condition.value;
        case 'le':
            return value <= condition.value;
        case 't':
            return true;
        case 'f': // fall through
        default:
            return false;
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function condition_get_matching(rendering, props) {
    for (var i = 0; i < rendering.length; ++i) {
        var cur = rendering[i];

        if (condition_check(cur.condition, props.value)) return cur.definitions;
    }

    // return empty default
    return {};
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function get_or_default(obj, key, def) {
    return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) == 'object' && key in obj ? obj[key] : def;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function set_or_extend(arr, idx, vals) {
    if (idx >= arr.length) arr.push(vals);else {
        var keys = Object.keys(vals);
        for (var i = 0; i < keys.length; ++i) {
            arr[idx][keys[i]] = vals[keys[i]];
        }
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// VUE default components
////////////////////////////////////////////////////////////////////////////////////////////////////////
// Clone {{{
// src: https://stackoverflow.com/a/728694
function clone(obj) {
    var copy;

    // Handle the 3 simple types, and null or undefined
    if (null == obj || 'object' != (typeof obj === 'undefined' ? 'undefined' : _typeof(obj))) return obj;

    // Handle Date
    if (obj instanceof Date) {
        copy = new Date();
        copy.setTime(obj.getTime());
        return copy;
    }

    // Handle Array
    if (obj instanceof Array) {
        copy = [];
        for (var i = 0, len = obj.length; i < len; i++) {
            copy[i] = clone(obj[i]);
        }
        return copy;
    }

    // Handle Object
    if (obj instanceof Object) {
        copy = {};
        for (var attr in obj) {
            if (obj.hasOwnProperty(attr)) copy[attr] = clone(obj[attr]);
        }
        return copy;
    }

    throw new Error('Unable to copy obj! Its type isn\'t supported.');
}
// }}}


// Utils {{{
Vue.component('shif-title', {
    props: {
        classname: String,
        disabled: {
            type: Object,
            default: function _default() {
                return { flag: false };
            }
        }
    },
    template: '\n        <div class="device_title" v-bind:class="classname">\n            <slot></slot>\n            <span v-if="disabled.flag" class="disabled_text">\n                {{ disabled.texts.title }}\n            </span>\n        </div>\n    '
});

Vue.component('shif-status', {
    props: ['classname', 'key_vals'],
    template: '\n        <div class="device_status" v-bind:class="classname">\n            <template v-if="key_vals">\n                <template v-if="key_vals.length === 0">\n                    <div class="device_status_entry"></div>\n                </template>\n                <template v-else>\n                    <span v-for="i in key_vals"\n                        class="device_status_entry">\n                        <span v-if="i.key" class="name">{{ i.key }}:</span>\n                        <span class="value">{{ i.value }}</span>\n                    </span>\n                </template>\n            </template>\n            <template v-else>\n                <div class="device_status_entry">\n                    <slot></slot>\n                </div>\n            </template>\n        </div>\n    '
});

Vue.component('shif-icon', {
    props: {
        src: {
            type: String,
            required: true
        },
        classname: String,
        active: String,
        rotate: Boolean
    },

    template: '\n        <div v-bind:class="classname">\n            <template v-if="src in interfaceIcons">\n                <div class="svg_icon"\n                     v-bind:class="[src, active, {accordion_arrow_rotated: rotate}]"\n                     v-html="interfaceIcons[src]">\n                </div>\n            </template>\n            <template v-else-if="src in interfaceData.iconFallback">\n                <div class="svg_icon"\n                     v-bind:class="[src, active, {accordion_arrow_rotated: rotate}]"\n                     v-html="interfaceIcons[interfaceData.iconFallback[src]]">\n                </div>\n            </template>\n            <template v-else>\n                <div class="svg_icon icon_default">\n                    <svg xmlns="http://www.w3.org/2000/svg" version="1.1" x="0" y="0" width="500" height="500" viewBox="0 0 500 500">\n                        <path d="M227.52 320.99L227.52 301.54Q227.52 289.25 229.31 279.52 231.1 269.79 234.94 261.09 238.78 252.38 245.18 244.19 251.58 236 261.31 226.78L284.35 204.77Q294.08 196.06 300.99 185.31 307.9 174.56 307.9 159.2 307.9 139.23 295.36 125.66 282.82 112.1 259.78 112.1 248 112.1 238.53 116.45 229.06 120.8 222.14 128.22 215.23 135.65 211.65 145.38 208.06 155.1 207.55 165.34L144.58 159.71Q147.65 135.14 157.63 115.94 167.62 96.74 183.49 83.42 199.36 70.11 219.84 63.2 240.32 56.29 263.87 56.29 285.89 56.29 305.6 62.69 325.31 69.09 340.42 81.63 355.52 94.18 364.22 112.61 372.93 131.04 372.93 155.1 372.93 171.49 369.34 183.78 365.76 196.06 359.1 206.3 352.45 216.54 342.98 226.02 333.5 235.49 321.73 245.73 311.49 254.43 305.09 261.09 298.69 267.74 294.85 274.4 291.01 281.06 289.47 288.74 287.94 296.42 287.94 307.68L287.94 320.99zM217.28 392.16Q217.28 375.78 229.31 364 241.34 352.22 258.24 352.22 274.62 352.22 286.91 363.49 299.2 374.75 299.2 391.14 299.2 407.52 287.17 419.3 275.14 431.07 258.24 431.07 250.05 431.07 242.62 428 235.2 424.93 229.57 419.81 223.94 414.69 220.61 407.52 217.28 400.35 217.28 392.16z"/>\n                    </svg>\n                </div>\n            </template>\n        </div>\n    '
});

Vue.component('shif-slider', {
    props: {
        min: Number,
        max: Number,
        unit: String,
        value: Number,
        title: String,
        step: Number,
        disabled: {
            type: Object,
            default: function _default() {
                return { flag: false };
            }
        },
        precision: {
            type: Number,
            default: 0
        }
    },

    computed: {
        value_formatted: function value_formatted() {
            return this.float_formatted(this.value, this.precision);
        }
    },

    template: '\n        <div class="device_wrapper" v-bind:class="{disabled: disabled.flag}">\n            <div class="device slider">\n                <shif-title v-bind:disabled="disabled">{{ title }}</shif-title>\n\n                <div class="slider_action">\n                    <div class="amount">\n                        <p>{{ value_formatted }} {{ unit }}</p>\n                    </div>\n                </div>\n\n                <input type="range"\n                        class="range"\n                        name="range"\n                        v-bind:step="step"\n                        v-bind:min="min"\n                        v-bind:max="max"\n                        v-bind:value="value"\n                        v-bind:disabled="disabled.flag"\n                        v-on:change="$emit(\'change\', parseFloat($event.target.value))"\n                        v-on:input="$emit(\'input\', parseFloat($event.target.value))" />\n\n                <div class="slider_marks">\n                    <div class="left">\n                        {{ min }} {{ unit }}\n                    </div>\n                    <div class="right">\n                        {{ max }} {{ unit }}\n                    </div>\n                </div>\n            </div>\n        </div>\n    '
});

Vue.component('shif-radio', {
    props: {
        title: String,
        classname: String,
        values: Array,
        disabled: {
            type: Object,
            default: function _default() {
                return { flag: false };
            }
        }
    },

    computed: {
        identifier: function identifier() {
            return 'x' + Math.random().toString(36).substring(10);
        }
    },

    template: '\n        <div class="device_wrapper" v-bind:class="{disabled: disabled.flag}">\n            <div class="device">\n                <shif-title v-bind:disabled="disabled">{{ title }}</shif-title>\n                <div class="device_radio">\n                    <template v-for="i in values">\n                        <label class="rad">\n                            <span class="rad_name">{{ i.name }}</span>\n                            <input type="radio"\n                                   v-bind:name="identifier"\n                                   v-bind:value="i.value"\n                                   v-bind:checked="i.selected"\n                                   v-bind:disabled="disabled.flag"\n                                   v-on:input="$emit(\'input\', $event.target.value)" />\n                            <i></i>\n                        </label>\n                    </template>\n                </div>\n            </div>\n        </div>\n    '
});

Vue.component('shif-button', {
    props: {
        width: {
            type: String,
            default: '100%'
        },
        classname: String,
        disabled: {
            type: Object,
            default: function _default() {
                return { flag: false };
            }
        }
    },
    template: '\n        <div class="control_button"\n             v-bind:class="{[classname]: true, disabled: disabled.flag}"\n             v-bind:style="{width}"\n             v-on:click="(!disabled.flag) && $emit(\'click\', 1)">\n            <slot></slot>\n        </div>\n    '
});

Vue.component('shif-colorpicker', {
    props: {
        width: { type: Number, required: true },
        height: { type: Number, required: true },
        color: { type: String, required: true },
        padding: { type: Number, default: 1 },
        borderWidth: { type: Number, default: 3 },
        markerRadius: { type: Number, default: 12 },
        sliderMargin: { type: Number, default: 24 },
        sliderHeight: { type: Number, default: 36 },
        borderColor: { type: String, default: '#fff' }
    },

    data: function data() {
        return {
            handle: null
        };
    },

    watch: {
        color: function color(color_new) {
            if (this.handle) this.handle.color.hexString = color_new;
        }
    },

    mounted: function mounted() {
        this.handle = new iro.ColorPicker(this.$refs.colorpicker, {
            width: this.width,
            height: this.height,
            color: this.color,
            markerRadius: this.markerRadius,
            padding: this.padding,
            sliderMargin: this.sliderMargin,
            sliderHeight: this.sliderHeight,
            borderWidth: this.borderWidth,
            borderColor: this.borderColor,
            anticlockwise: true
        });

        // `on` patches `this`.
        // So we need to back it up first.
        var outer = this;
        this.handle.on('color:change', function (color, changes) {
            outer.$emit('color:change', { color: color, changes: changes });
        });
        this.handle.on('input:start', function (color, changes) {
            outer.$emit('input:start', { color: color, changes: changes });
        });
        this.handle.on('input:end', function (color, changes) {
            outer.$emit('input:end', { color: color, changes: changes });
        });
    },

    template: '\n        <div ref="colorpicker">\n        </div>\n    '
});
// }}}


// Generic l2 {{{
Vue.component('shif-generic-l2', {
    props: {
        icon: String,
        place: String,
        title: String,
        status: [Array, String],
        actions: Boolean,
        icon_rotate: Boolean,
        accordion: Boolean,
        disabled: {
            type: Object,
            default: function _default() {
                return { flag: false };
            }
        },
        active: {
            type: Object,

            default: function _default() {
                return {
                    icon: '',
                    text: ''
                };
            }
        }
    },

    mounted: function mounted() {
        if (this.$listeners && this.$listeners.click !== undefined && this.$listeners.click_icon === undefined) this.$on('click_icon', this.$listeners.click);
    },

    methods: {
        emit: function emit(key, val) {
            if (this.disabled.flag) return;

            if (val === undefined) this.$emit(key);else this.$emit(key, val);
        }
    },

    template: '\n        <div class="device_wrapper"\n             v-bind:class="{disabled: disabled.flag}"\n             v-on:mousedown="emit(\'mousedown\')"\n             v-on:mouseup="emit(\'mouseup\')"\n             v-on:click="emit(\'click\')">\n            <div class="device">\n                <div v-on:click.stop="emit(\'click_icon\')">\n                    <shif-icon v-bind:src="icon"\n                               v-bind:active="active.icon"\n                               classname="device_icon">\n                    </shif-icon>\n                </div>\n                <div class="device_text">\n                    <shif-title v-bind:disabled="disabled">{{ title }}</shif-title>\n                    <div v-if="place" class="device_location">\n                        {{ place }}\n                    </div>\n                    <template v-if="typeof(status) === \'object\'">\n                        <shif-status v-bind:classname="active.text"\n                                     v-bind:key_vals="status">\n                        </shif-status>\n                    </template>\n                    <template v-else>\n                        <shif-status v-bind:classname="active.text">{{ status }}</shif-status>\n                    </template>\n                </div>\n                <div v-if="actions"\n                     class="device_action">\n                    <template v-if="accordion">\n                        <shif-icon src="arrow_down_1" v-bind:rotate="icon_rotate"></shif-icon>\n                    </template>\n                    <template v-else>\n                        <div class="svg_icon arrow_right_1">\n                            <svg xmlns="http://www.w3.org/2000/svg" version="1.1" id="svg" x="0" y="0" width="370.81" height="370.81" viewBox="0 0 370.81 370.81">\n                                <g id="Ebene_1">\n                                    <path d="M77.9 345.97L102.03 370.81 292.92 185.41 102.03 0 77.9 24.85 243.18 185.41z"/>\n                                </g>\n                            </svg>\n                        </div>\n                    </template>\n                </div>\n            </div>\n        </div>\n    '
});
// }}}


// [shif_device] Generic Shif Device Component Object {{{
function status_impl(control) {
    var out = [];

    var key = control.texts && control.texts.l2_state_title && control.texts.l2_state_title.content ? control.texts.l2_state_title.content : null;
    var val = [];

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
        for (var _iterator2 = control.variableInputs[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var input = _step2.value;

            if (!input.properties.visualizeInOverview) continue;

            if (input.rendering) {
                var sel = condition_get_matching(input.rendering, input.properties);
                if (Object.keys(sel).length > 0) {
                    val.push(sel.texts.state.content);
                    continue;
                }
            }

            var unit = input.properties.unit ? input.properties.unit : '';
            val.push(input.properties.value + unit);
        }
    } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
            }
        } finally {
            if (_didIteratorError2) {
                throw _iteratorError2;
            }
        }
    }

    if (val.length > 0) out.push({ key: key, value: val.join(', ') });

    return out;
}

var shif_device = {
    props: ['uiElement', 'control', 'device', 'icons', 'texts', 'output', 'props', 'indexes', 'rendering', 'include_place'],

    data: function data() {
        return {
            lastClickCount: 0
        };
    },

    methods: {
        status_minimal: function status_minimal() {
            var descs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            var raw = status_impl(this.control);

            return descs ? raw : raw.map(function (x) {
                return { value: x.value };
            });
        }
    },

    computed: {
        cond: function cond() {
            var sel = condition_get_matching(this.rendering, this.props);

            return {
                text: get_or_default(sel.texts, 'state', { content: '', color: '' }),
                icon: get_or_default(sel.icons, 'state', { name: '', color: '' })
            };
        },

        dev: function dev() {
            return interfaceData.devices[this.device];
        },

        place: function place() {
            if (!this.include_place) return null;

            var room = interfaceData.rooms[this.dev.room];
            if (interfaceData.options.showFloor !== true) return room.name;

            return room.floors.map(function (x) {
                return interfaceData.floors[x];
            }).map(function (x) {
                return x.name + ' - ' + room.name;
            }).join(' | ');
        },

        title: function title() {
            if (this.control.texts && this.control.texts.title && this.control.texts.title.content) return this.control.texts.title.content;

            return this.dev.label;
        },

        status: function status() {
            var out = [];

            var _iteratorNormalCompletion3 = true;
            var _didIteratorError3 = false;
            var _iteratorError3 = undefined;

            try {
                for (var _iterator3 = this.dev.controls[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                    var control = _step3.value;

                    out = out.concat(status_impl(control));
                }
            } catch (err) {
                _didIteratorError3 = true;
                _iteratorError3 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }
                } finally {
                    if (_didIteratorError3) {
                        throw _iteratorError3;
                    }
                }
            }

            return out;
        },

        breadcrumb: function breadcrumb() {
            return (this.place ? this.place + ' | ' : '') + this.dev.label;
        },

        disabled: function disabled() {
            return check_disabled(this.uiElement, this.indexes);
        }
    }
};

function shif_comps_create(name, l2, l3) {
    var shif_name = 'shif-' + name + '-';

    controlComponents[name] = {
        l2: Vue.component(shif_name + 'l2', l2),
        l3: Vue.component(shif_name + 'l3', l3)
    };
}
// }}}


////////////////////////////////////////////////////////////////////////////////////////////////////////
// liefert den view für das Editieren der Benutzereinstellungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user(options) {
    var themesNames = [];
    var _iteratorNormalCompletion4 = true;
    var _didIteratorError4 = false;
    var _iteratorError4 = undefined;

    try {
        for (var _iterator4 = interfaceData.themes[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var i = _step4.value;

            if (i.name === 'standard' || i.name === 'highlight') continue;

            var selected = interfaceData.options.theme == i.name ? 'selected' : '';
            themesNames.push('\n            <option value="' + i.name + '" autocomplete="off" ' + selected + '>\n                ' + i18n('settings.user.manage.theme.' + i.name) + '\n            </option>\n        ');
        }
    } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion4 && _iterator4.return) {
                _iterator4.return();
            }
        } finally {
            if (_didIteratorError4) {
                throw _iteratorError4;
            }
        }
    }

    var langNames = [];
    $.each(interfaceData.i18n.languages, function (key, value) {
        var selected = interfaceData.options.language == key ? 'selected' : '';
        langNames.push('\n            <option value="' + key + '" autocomplete="off" ' + selected + '>\n                ' + value.name + '\n            </option>\n        ');
    });

    var output = '\n        <div id="user_wrapper">\n        <form id="user_' + options.content + '" name="user_' + options.content + '" action="javascript:void(0);" onsubmit="user_' + options.content + '_commit();">\n    ';
    if (interfaceData.options.twofaChangeable == true) {
        output += '\n                <div id="twofaContainer" class="form-group" style="display: none">\n                    <div class="label">' + i18n('settings.user.manage.twofa') + ':</div>\n                    <input id="registerWebauthn" onclick="user_register_webauthn_device()" type="button" class="" ' + (interfaceData.options.userHasTwofaRegistrations ? 'disabled="disabled"' : '') + ' value="' + (interfaceData.options.userHasTwofaRegistrations ? i18n('settings.user.manage.twofaRegistered') : i18n('settings.user.manage.registerTwofa')) + '">\n                </div>\n        ';
    }
    if (interfaceData.options.languageChangeable == true) {
        output += '\n            <div class="form-group">\n                <div class="label">' + i18n('settings.user.manage.language') + ':</div>\n                <select id="language" name="language">\n                    ' + langNames + '\n                </select>\n            </div>\n        ';
    }
    output += '\n            <div class="form-group">\n                <div class="label">' + i18n('settings.user.manage.theme') + ':</div>\n                <select id="theme" name="theme">\n                    ' + themesNames + '\n                </select>\n            </div>\n    ';
    output += '\n            <div id="user_highlight_display" class="form-group">\n                <div class="label">' + i18n('settings.user.manage.highlight') + ':</div>\n                <input id="highlight" type="hidden" name="highlight" value="' + interfaceData.options.highlight + '">\n                    <div id="color-picker-container"></div>\n                <div style="clear:both;"></div>\n            </div>\n    ';
    output += '\n            <div class="form-group">\n                <input type="submit" class="" name="user_' + options.content + '" value="' + i18n('settings.user.manage.save') + '">\n            </div>\n        </form>\n        </div>\n    ';

    content('this', { 'content': output, 'name': options['name'] });
    if (interfaceData.options.twofaEnabled) $('#twofaContainer').show();

    var outerWidth = $('#user_edit').outerWidth();
    var userColorPickerWidth = outerWidth <= 400 ? outerWidth : 400;
    var userColorPickerHeight = userColorPickerWidth + 20;

    var userColorPicker = new iro.ColorPicker('#color-picker-container', {
        width: userColorPickerWidth,
        height: userColorPickerHeight,
        color: interfaceData.options.highlight,
        markerRadius: 12,
        padding: 1,
        sliderMargin: 24,
        sliderHeight: 36,
        borderWidth: 3,
        borderColor: '#fff',
        anticlockwise: true
    });

    userColorPicker.on('color:change', function (color, changes) {
        $('#user_highlight_display #highlight').val(color.hexString);
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Register a new WebAuthn device
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_register_webauthn_device() {
    /**
     * convert RFC 1342-like base64 strings to array buffer
     * @param {mixed} obj
     * @returns {undefined}
     */
    function recursiveBase64StrToArrayBuffer(obj) {
        var prefix = '?BINARY?B?';
        var suffix = '?=';
        if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
            for (var key in obj) {
                if (typeof obj[key] === 'string') {
                    var str = obj[key];
                    if (str.substring(0, prefix.length) === prefix && str.substring(str.length - suffix.length) === suffix) {
                        str = str.substring(prefix.length, str.length - suffix.length);

                        var binary_string = window.atob(str);
                        var len = binary_string.length;
                        var bytes = new Uint8Array(len);
                        for (var i = 0; i < len; i++) {
                            bytes[i] = binary_string.charCodeAt(i);
                        }
                        obj[key] = bytes.buffer;
                    }
                } else {
                    recursiveBase64StrToArrayBuffer(obj[key]);
                }
            }
        }
    }

    /**
     * Convert a ArrayBuffer to Base64
     * @param {ArrayBuffer} buffer
     * @returns {String}
     */
    function arrayBufferToBase64(buffer) {
        var binary = '';
        var bytes = new Uint8Array(buffer);
        var len = bytes.byteLength;
        for (var i = 0; i < len; i++) {
            binary += String.fromCharCode(bytes[i]);
        }
        return window.btoa(binary);
    }

    if (interfaceData.options.userHasTwofaRegistrations) return;
    if (!window.fetch || !navigator.credentials || !navigator.credentials.create) {
        $('#registerWebauthn').val(i18n('settings.user.manage.browserNotSupported'));
        $('#registerWebauthn').attr('disabled', 'disabled');
        return;
    }

    window.fetch('webauthnServer.php?command=getCredentialArgs', { method: 'GET', cache: 'no-cache' }).then(function (response) {
        return response.json();
    }).then(function (json) {
        recursiveBase64StrToArrayBuffer(json);
        return json;
    }).then(function (createCredentialArgs) {
        return navigator.credentials.create(createCredentialArgs);
    }).then(function (cred) {
        return {
            clientDataJson: cred.response.clientDataJSON ? arrayBufferToBase64(cred.response.clientDataJSON) : null,
            attestationObject: cred.response.attestationObject ? arrayBufferToBase64(cred.response.attestationObject) : null
        };
    }).then(JSON.stringify).then(function (AuthenticatorAttestationResponse) {
        return window.fetch('webauthnServer.php?command=registerDevice', { method: 'POST', body: AuthenticatorAttestationResponse, cache: 'no-cache' });
    }).then(function (response) {
        return response.json();
    }).then(function (json) {
        if (json.success) {
            $('#registerWebauthn').val(i18n('settings.user.manage.twofaRegistered'));
            $('#registerWebauthn').attr('disabled', 'disabled');
        } else {
            throw new Error(json.msg);
        }
    }).catch(function (error) {
        $('#registerWebauthn').val(error.message);
        $('#registerWebauthn').attr('disabled', 'disabled');
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// verarbeitet das Editieren der Benutzereinstellungen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function user_edit_commit() {
    interfaceData.options.theme = $('#user_edit #theme').val() || 'dark';
    interfaceData.options.highlight = $('#user_edit #highlight').val() || '#e3a104';
    interfaceData.options.language = $('#user_edit #language').val() || interfaceData.options.language || 'en-US';

    var rpc_obj_get = {
        jsonrpc: '2.0',
        method: 'getUserMetadata',
        params: []
    };

    homegear.invoke(rpc_obj_get, updateUserSettingsData);

    function updateUserSettingsData(data) {
        var newUserSettings = data.result;

        newUserSettings.interface = newUserSettings.interface || {};
        newUserSettings.locale = interfaceData.options.language;
        newUserSettings.interface.language = interfaceData.options.language;
        newUserSettings.interface.theme = interfaceData.options.theme;
        newUserSettings.interface.highlight = interfaceData.options.highlight;

        var rpc_obj = {
            jsonrpc: '2.0',
            method: 'setUserMetadata',
            params: [newUserSettings]
        };

        homegear.invoke(rpc_obj, function () {
            window.location.reload(true);
        });
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var shading_windalarm = clone(shif_device);
shading_windalarm.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('shadingWindalarm', shading_windalarm, shading_windalarm);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var shading_ventilation_l2 = clone(shif_device);
shading_ventilation_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
shading_ventilation_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var shading_ventilation_l3 = clone(shif_device);
shading_ventilation_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
shading_ventilation_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal()"\n                     v-bind:disabled="disabled"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('shadingVentilation', shading_ventilation_l2, shading_ventilation_l3);

var shading_slider = clone(shif_device);
shading_slider.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
shading_slider.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-bind:step=5\n                 v-bind:disabled="disabled"\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('shadingPosition', shading_ventilation_l2, shading_slider);
shif_comps_create('shadingPositionSlats', shading_ventilation_l2, shading_slider);

var shading_buttons_l2 = clone(shif_device);
shading_buttons_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var shading_buttons_l3 = clone(shif_device);
shading_buttons_l3.methods.change = function (event) {
    var upVar = this.control.variableOutputs[0];
    var downVar = this.control.variableOutputs[2];
    if ((this.indexes.input == 0 || this.indexes.input == 2) && !upVar.hasOwnProperty('value') && !downVar.hasOwnProperty('value') && upVar.peer == downVar.peer && upVar.channel == downVar.channel && upVar.name == downVar.name) {
        var down = this.indexes.input == 2;
        if ((this.output.type == 'integer' || this.output.type == 'integer64' || this.output.type == 'float') && this.output.hasOwnProperty('minimumValue') && this.output.hasOwnProperty('maximumValue')) {
            var output = clone(this.output);
            output.value = down ? this.output.maximumValue : this.output.minimumValue;
            homegear.value_set_clickcounter(this, output, null);
        } else if (this.output.type == 'bool') {
            var _output = clone(this.output);
            _output.value = down;
            homegear.value_set_clickcounter(this, _output, null);
        }
    } else homegear.value_set_clickcounter(this, this.output, true);
};
shading_buttons_l3.template = '\n    <div class="control_button_wrapper">\n        <shif-button v-bind:disabled="disabled"\n                     v-on:click="change">\n            <shif-icon v-bind:src="cond.icon.name"\n                        v-bind:active="cond.icon.color">\n            </shif-icon>\n        </shif-button>\n    </div>\n';

shif_comps_create('shadingButtons', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);
shif_comps_create('shadingButtonsSingleStep', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);
shif_comps_create('shadingButtonsUpDown', shading_buttons_l2, shading_buttons_l3, shading_buttons_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var window_rainalarm = clone(shif_device);
window_rainalarm.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('windowRainalarm', window_rainalarm, window_rainalarm);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var window_status = clone(shif_device);
window_status.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

var window_status_l3 = clone(shif_device);
window_status_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('windowContact', window_status, window_status_l3);
shif_comps_create('windowHandle', window_status, window_status_l3);

var window_buttons_l2 = clone(shif_device);
window_buttons_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var window_buttons_l3 = clone(shif_device);
window_buttons_l3.methods.change = function (event) {
    var upVar = this.control.variableOutputs[0];
    var downVar = this.control.variableOutputs[2];
    if ((this.indexes.input == 0 || this.indexes.input == 2) && !upVar.hasOwnProperty('value') && !downVar.hasOwnProperty('value') && upVar.peer == downVar.peer && upVar.channel == downVar.channel && upVar.name == downVar.name) {
        var down = this.indexes.input == 2;
        if ((this.output.type == 'integer' || this.output.type == 'integer64' || this.output.type == 'float') && this.output.hasOwnProperty('minimumValue') && this.output.hasOwnProperty('maximumValue')) {
            var output = clone(this.output);
            output.value = down ? this.output.maximumValue : this.output.minimumValue;
            homegear.value_set_clickcounter(this, output, null);
        } else if (this.output.type == 'bool') {
            var _output2 = clone(this.output);
            _output2.value = down;
            homegear.value_set_clickcounter(this, _output2, null);
        }
    } else homegear.value_set_clickcounter(this, this.output, true);
};
window_buttons_l3.template = '\n    <div>\n        <div class="control_button_wrapper">\n            <shif-button v-bind:disabled="disabled"\n                         v-on:click="change">\n                <shif-icon v-bind:src="cond.icon.name"\n                           v-bind:active="cond.icon.color">\n                </shif-icon>\n            </shif-button>\n        </div>\n    </div>\n';

shif_comps_create('windowButtonsUpDown', window_buttons_l2, window_buttons_l3, window_buttons_l3);
shif_comps_create('windowButtons', window_buttons_l2, window_buttons_l3, window_buttons_l3);

var window_slider = clone(shif_device);
window_slider.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
window_slider.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-bind:step=5\n                 v-bind:disabled="disabled"\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('windowPosition', window_buttons_l2, window_slider);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var door_status = clone(shif_device);
door_status.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('doorContact', door_status, door_status);
shif_comps_create('doorHandle', door_status, door_status);
shif_comps_create('doorLock', door_status, door_status);

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Auflisten der Räume
////////////////////////////////////////////////////////////////////////////////////////////////////////
var house_level1_content = '';

function house_level1() {
    $.each(interfaceData.floors, function (floorKey, floorValue) {
        // Stockwerktitel anzeigen, wenn mehr als ein Stockwerk vorhanden ist
        if (Object.keys(interfaceData.floors).length > 1) house_level1_content += '\n                <div class="roomSelectTitle">\n                    ' + floorValue.name + '\n                </div>\n            ';

        house_level1_content += '<div class="rooms_wrapper">';

        $.each(floorValue.rooms, function (_, roomValue) {
            var floorBreadcrumbName = interfaceData.options.showFloor === true ? floorValue.name + ' - ' : '';

            var action = 'onclick=\'house_level2( this, {"name":"' + floorBreadcrumbName + interfaceData.rooms[roomValue]['name'] + '", "floor":"' + floorKey + '", "room":"' + roomValue + '"});\'';

            house_level1_content += '\n                <div class="roomSelect_wrapper" ' + action + '>\n                    <div class="roomSelect">\n                        ' + showIcon(interfaceData.rooms[roomValue].icon) + '\n                    </div>\n                    <div class="description">\n                        ' + interfaceData.rooms[roomValue].name + '\n                    </div>\n                </div>\n            ';
        });

        house_level1_content += '</div>';
    });
}

// TODO: Return value?
house_level1();

function house_level1_fix() {
    var maxWidth = 0;
    $('.rooms_wrapper').each(function () {
        if ($(this).width() > maxWidth) {
            maxWidth = $(this).width();
        }
    });
    $('.roomSelectTitle').width(maxWidth);
    $('.rooms_wrapper').css('display', 'block');
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function check_disabled(device, indexes) {
    function check_event_trigger(event) {
        if (event.trigger == undefined || event.trigger.length != 3) return false;

        var trigger = event.trigger;
        return trigger[0] in interfaceData.map_invoke && trigger[1] in interfaceData.map_invoke[trigger[0]] && trigger[2] in interfaceData.map_invoke[trigger[0]][trigger[1]];
    }

    function check_event_disable(event, control_idx) {
        return 'disable' in event && control_idx in event.disable;
    }

    function check_event_condition(event) {
        return 'condition' in event && 'operator' in event.condition && 'value' in event.condition;
    }

    var ret_enabled = { flag: false };

    if (!('metadata' in device && 'event_hooks' in device.metadata)) return ret_enabled;

    var _iteratorNormalCompletion5 = true;
    var _didIteratorError5 = false;
    var _iteratorError5 = undefined;

    try {
        for (var _iterator5 = device.metadata.event_hooks[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var event = _step5.value;

            if (!check_event_trigger(event) || !check_event_disable(event, indexes.control) || !check_event_condition(event)) continue;

            var trigger = event.trigger;
            var disable = event.disable;
            var condition = event.condition;

            if (!disable[indexes.control]) continue;

            var devices = interfaceData.map_invoke[trigger[0]][trigger[1]][trigger[2]];
            var _iteratorNormalCompletion6 = true;
            var _didIteratorError6 = false;
            var _iteratorError6 = undefined;

            try {
                for (var _iterator6 = devices[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                    var dev = _step6.value;

                    var res = condition_check(condition, interfaceData.devices[dev.databaseId].controls[dev.control].variableInputs[dev.input].properties.value);
                    if (res) return {
                        flag: true,
                        texts: event.texts
                    };
                }
            } catch (err) {
                _didIteratorError6 = true;
                _iteratorError6 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion6 && _iterator6.return) {
                        _iterator6.return();
                    }
                } finally {
                    if (_didIteratorError6) {
                        throw _iteratorError6;
                    }
                }
            }
        }
    } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
                _iterator5.return();
            }
        } finally {
            if (_didIteratorError5) {
                throw _iteratorError5;
            }
        }
    }

    return ret_enabled;
}

function component_create(constructor, data) {
    var comp = new constructor({
        propsData: data
    });

    comp.$mount();

    return comp.$el;
}

function component_object(control, device, input, output, is, indexes) {
    var ret = {
        uiElement: device,
        control: control,
        device: device.databaseId,
        icons: device.icons,
        texts: device.texts,
        output: output,
        props: input.properties,
        indexes: indexes,
        rendering: input.rendering
    };

    if (is) ret.is = is;

    return ret;
}

function components_create(device, layer) {
    var out = [];

    // console.log(device.label + ': ' + device.databaseId + ': ' + layer);

    if (layer == 'l2' && _typeof(device.metadata) == 'object') {
        if ('l2_action' in device.metadata) {
            var keys = device.metadata.l2_action;

            var control = device.controls[keys.control];
            var input = control.variableInputs[keys.input];
            var output = control.variableOutputs[keys.input];

            return [component_create(controlComponents[control.control].l2, component_object(control, device, input, output, null, { input: keys.input, control: keys.control }))];
        }

        if (device.controls.length <= 1 && (!('l3_force' in device.metadata) || device.metadata.l3_force !== true)) layer = 'l3';
    }

    for (var i = 0; i < device.controls.length; ++i) {
        var _control = device.controls[i];

        // console.log(device.label + ': ' + device.databaseId + ': ' + layer + ': ' + control.control);

        if (!(_control.control in controlComponents) || !(layer in controlComponents[_control.control])) continue;

        for (var k in _control.variableInputs) {
            var _input = _control.variableInputs[k];
            var _output3 = _control.variableOutputs[k];

            out.push(component_create(controlComponents[_control.control][layer], component_object(_control, device, _input, _output3, null, { input: k, control: i })));
        }
    }

    return out;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Auflisten der Geräte eines Raums
////////////////////////////////////////////////////////////////////////////////////////////////////////
function house_level2(element, options) {
    var elements = [];
    var devices = interfaceData.rooms[options.room].devices.map(function (dev) {
        return interfaceData.devices[dev];
    });

    var _iteratorNormalCompletion7 = true;
    var _didIteratorError7 = false;
    var _iteratorError7 = undefined;

    try {
        for (var _iterator7 = devices[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
            var dev = _step7.value;

            elements = elements.concat(components_create(dev, 'l2'));
        }
    } catch (err) {
        _didIteratorError7 = true;
        _iteratorError7 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion7 && _iterator7.return) {
                _iterator7.return();
            }
        } finally {
            if (_didIteratorError7) {
                throw _iteratorError7;
            }
        }
    }

    content(this, {
        content: elements,
        name: options.name,
        vue: true
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function house_level3(element, options) {
    var device = interfaceData.devices[options.device];

    content(this, {
        content: components_create(device, 'l3'),
        name: options.name,
        vue: true
    });
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
Vue.use({
    install: function install(Vue, opts) {
        Vue.prototype.$homegear = homegear;
    }
});

Vue.mixin({
    data: function data() {
        return {
            debug: false,
            interfaceIcons: icons,
            interfaceData: interfaceData
        };
    },

    filters: {
        pretty: function pretty(val) {
            return JSON.stringify(val, null, 4);
        },

        warn: function warn(val) {
            console.warn(val);
        },

        log: function log(val) {
            console.log(val);
        }
    },

    methods: {
        level3: function level3(device, name) {
            house_level3(this, {
                device: device,
                name: name
            });
        },

        round: function round(val, precision) {
            var mul = Math.pow(10, precision || 0);

            return Math.round(val * mul) / mul;
        },

        float_formatted: function float_formatted(val) {
            var precision = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

            return parseFloat(val).toFixed(precision);
        }
    }
});

Vue.component('shif-ctrl-summary', {
    props: ['icon', 'title', 'status', 'actions', 'devs', 'role_id'],

    data: function data() {
        return {
            submenu_show: false
        };
    },

    computed: {
        dev_objs: function dev_objs() {
            var _this = this;

            return this.devs.map(function (x) {
                return _this.find_component(_this.interfaceData.devices[x], 'l2');
            });
        }
    },

    methods: {
        find_component: function find_component(device, layer) {
            if (layer == 'l2' && _typeof(device.metadata) == 'object') {
                if ('l2_action' in device.metadata) {
                    var keys = device.metadata.l2_action;

                    var control = device.controls[keys.control];
                    var input = control.variableInputs[keys.input];
                    var output = control.variableOutputs[keys.input];
                    var is = 'shif-' + control.control + '-l2';

                    return [component_object(control, device, input, output, is, { input: keys.input, control: keys.control })];
                }

                if (device.controls.length <= 1 && (!('l3_force' in device.metadata) || device.metadata.l3_force !== true)) layer = 'l3';
            }

            var out = [];
            // for (const control of device.controls) {
            for (var i = 0; i < device.controls.length; ++i) {
                var _control2 = device.controls[i];

                for (var k in _control2.variableInputs) {
                    var _input2 = _control2.variableInputs[k];
                    var _output4 = _control2.variableOutputs[k];
                    var _is = 'shif-' + _control2.control + '-' + layer;

                    out.push(component_object(_control2, device, _input2, _output4, _is, { input: k, control: i }));
                }
            }

            return out;
        },

        toggle_all: function toggle_all(action) {
            var _this2 = this;

            var varInRole = 'roleId' in action ? this.interfaceData.roles[action.roleId].varInRole : this.interfaceData.roles[this.role_id].varInRole;

            var ops = [];
            for (var peer in varInRole) {
                for (var channel in varInRole[peer]) {
                    for (var name in varInRole[peer][channel]) {
                        var cur = varInRole[peer][channel][name];

                        if ('direction' in cur && cur.direction === 0) continue;

                        if (!(peer in this.interfaceData.map_invoke && channel in this.interfaceData.map_invoke[peer] && name in this.interfaceData.map_invoke[peer][channel])) continue;
                        var devs = this.interfaceData.map_invoke[peer][channel][name];

                        var disabled = devs.some(function (dev) {
                            var device = _this2.interfaceData.devices[dev.databaseId];
                            var control = device.controls[dev.control];

                            for (var i in control.variableInputs) {
                                if (check_disabled(device, { control: dev.control, input: i }).flag) return true;
                            }

                            return false;
                        });

                        if (!disabled) ops.push({
                            input: { peer: peer, channel: channel, name: name },
                            value: action.value
                        });
                    }
                }
            }this.$homegear.value_set_multi(ops);
        }

    },

    template: '\n        <div>\n            <shif-generic-l2 v-bind:icon="icon"\n                             v-bind:icon_rotate="submenu_show"\n                             v-bind:title="title"\n                             v-bind:status="status"\n                             v-bind:actions="true"\n                             v-bind:accordion="true"\n                             v-on:click="submenu_show = !submenu_show"\n                             class="accordion">\n            </shif-generic-l2>\n\n            <transition name="slide-fade">\n                <div v-if="submenu_show"\n                     class="categoryContainer"\n                     style="margin-top: 15px;">\n                    <div class="control_button_wrapper">\n                        <template v-for="action in actions">\n                            <shif-button v-bind:width="(100 / actions.length) + \'%\'"\n                                         v-on:click="toggle_all(action)">\n                                {{ action.buttonText }}\n                            </shif-button>\n                        </template>\n                    </div>\n\n                    <template v-for="dev in dev_objs">\n                        <component v-bind="dev" v-bind:include_place="true">\n                        </component>\n\n                        <template v-if="debug">\n                            {{ dev | pretty | log }}\n                        </template>\n                    </template>\n                </div>\n            </transition>\n        </div>\n    '
});

var ShifAllDevices = {
    data: function data() {
        var states = {};

        /**
         * Initialize the states so that the status component can show an empty
         * status line without error.
         **/
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
            for (var _iterator8 = Object.keys(interfaceData.roles).map(Number)[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
                var key = _step8.value;

                states[key] = [];
            }
        } catch (err) {
            _didIteratorError8 = true;
            _iteratorError8 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion8 && _iterator8.return) {
                    _iterator8.return();
                }
            } finally {
                if (_didIteratorError8) {
                    throw _iteratorError8;
                }
            }
        }

        return {
            status_initialized: false,
            states: states
        };
    },

    computed: {
        map_roles_devs: function map_roles_devs() {
            var ret = {};

            for (var dev_idx in interfaceData.devices) {
                var dev = interfaceData.devices[dev_idx];
                if (!('role' in dev)) continue;

                var role = dev.role;
                if (!(role in ret)) ret[role] = [];

                if (ret[role].indexOf(dev_idx) === -1) ret[role].push(dev_idx);
            }

            return ret;
        }
    },

    methods: {
        status_gather_invokes: function status_gather_invokes(role, role_id) {
            var ret = [{
                type: get_or_default(role, 'aggregationType', 2),
                ids: [{ 'id': role_id, 'direction': 0 }]
            }];

            if (!('rolesInclude' in role)) return ret;

            var _iteratorNormalCompletion9 = true;
            var _didIteratorError9 = false;
            var _iteratorError9 = undefined;

            try {
                for (var _iterator9 = role.rolesInclude[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
                    var role_inc = _step9.value;

                    var ids = [];
                    for (var index in role_inc.roles) {
                        ids.push({ 'id': role_inc.roles[index], 'direction': 0 });
                    }

                    ret.push({
                        type: get_or_default(role_inc, 'aggregationType', 2),
                        ids: ids
                    });
                }
            } catch (err) {
                _didIteratorError9 = true;
                _iteratorError9 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion9 && _iterator9.return) {
                        _iterator9.return();
                    }
                } finally {
                    if (_didIteratorError9) {
                        throw _iteratorError9;
                    }
                }
            }

            return ret;
        },

        status_text: function status_text(role, texts_idx) {
            if (!('texts' in role)) return '?';

            if (typeof texts_idx === 'number' && role.texts.length > texts_idx || typeof texts_idx === 'string' && texts_idx in role.texts) return role.texts[texts_idx];

            if (role.texts.length == 1) return role.texts[0];

            return '?';
        },

        status: function status(role_id) {
            var _this3 = this;

            var role = interfaceData.roles[role_id];
            var invokes_descs = this.status_gather_invokes(role, role_id);

            if ('l2_status' in role) {
                this.states[role_id] = [];
                return;
            }

            var _loop = function _loop(invoke_desc) {
                _this3.$homegear.invoke({
                    jsonrpc: '2.0',
                    method: 'aggregateRoles',
                    params: [invoke_desc.type, invoke_desc.ids, []]
                }, function (res) {
                    if (res.error) {
                        console.log('[' + invoke_desc.ids.join(', ') + ']: ' + res.error.message);
                        return;
                    }

                    /**
                     * Updating this is a two step process:
                     * 1) We need to fetch the new values from upstream.
                     * 2) We need to zero out the outdated old values.
                     **/
                    var keys = Object.keys(res.result).filter(function (x) {
                        return x !== 'variableCount';
                    });
                    var _iteratorNormalCompletion11 = true;
                    var _didIteratorError11 = false;
                    var _iteratorError11 = undefined;

                    try {
                        for (var _iterator11 = keys[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
                            var key = _step11.value;

                            /**
                             * We have to be very careful here, to not break Vue's
                             * reactiveness.
                             * 1) In case we need to insert a value, push is needed.
                             * 2) In case we need to change a value, direct
                             *    assignment of the single object members at
                             *    relative array index is needed.
                             **/
                            for (var i = 0; i < _this3.states[role_id].length; ++i) {
                                if (_this3.states[role_id][i].raw == key) {
                                    set_or_extend(_this3.states[role_id], i, {
                                        key: _this3.status_text(role, key),
                                        value: res.result[key],
                                        raw: key
                                    });
                                    break;
                                }
                            }
                        }
                    } catch (err) {
                        _didIteratorError11 = true;
                        _iteratorError11 = err;
                    } finally {
                        try {
                            if (!_iteratorNormalCompletion11 && _iterator11.return) {
                                _iterator11.return();
                            }
                        } finally {
                            if (_didIteratorError11) {
                                throw _iteratorError11;
                            }
                        }
                    }

                    for (var j = _this3.states[role_id].length - 1; j >= 0; --j) {
                        if (keys.indexOf(_this3.states[role_id][j].raw) === -1) _this3.states[role_id][j].value = 0;
                    }
                });
            };

            var _iteratorNormalCompletion10 = true;
            var _didIteratorError10 = false;
            var _iteratorError10 = undefined;

            try {
                for (var _iterator10 = invokes_descs[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
                    var invoke_desc = _step10.value;

                    _loop(invoke_desc);
                }
            } catch (err) {
                _didIteratorError10 = true;
                _iteratorError10 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion10 && _iterator10.return) {
                        _iterator10.return();
                    }
                } finally {
                    if (_didIteratorError10) {
                        throw _iteratorError10;
                    }
                }
            }
        },

        states_clean: function states_clean(role_id) {
            return this.states[role_id].some(function (x) {
                return x.value !== 0;
            }) ? this.states[role_id] : [];
        }
    },

    mounted: function mounted() {
        var _this4 = this;

        this.$homegear.ready(function () {
            var _iteratorNormalCompletion12 = true;
            var _didIteratorError12 = false;
            var _iteratorError12 = undefined;

            try {
                for (var _iterator12 = Object.keys(interfaceData.roles).map(Number)[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
                    var key = _step12.value;

                    var role = interfaceData.roles[key];

                    if (!('texts' in role)) continue;

                    /**
                     * Always reinitialize to an empty array here.
                     * In case of a homegear reconnect, we would duplicate the
                     * status text otherwise.
                     **/
                    _this4.states[key] = [];
                    /**
                     * This must be a for-in loop! Do not change it into a
                     * traditional for loop or a map.
                     * We need iterate over both, integer keys, as well as object
                     * keys (iteration order does not matter for the integer keys).
                     **/
                    for (var text_idx in role.texts) {
                        _this4.states[key].push({
                            key: _this4.status_text(role, text_idx),
                            raw: text_idx + '',
                            value: 0
                        });
                    }_this4.status(key);
                }
            } catch (err) {
                _didIteratorError12 = true;
                _iteratorError12 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion12 && _iterator12.return) {
                        _iterator12.return();
                    }
                } finally {
                    if (_didIteratorError12) {
                        throw _iteratorError12;
                    }
                }
            }
        });

        this.$root.$on('role-update', function (role_id) {
            return _this4.status(Number(role_id));
        });
    },

    template: '\n        <div>\n            <template v-for="(devs, role) in map_roles_devs">\n                <template v-if="role in interfaceData.roles">\n                    <shif-ctrl-summary\n                        v-on:role_update="status"\n                        v-bind:actions="interfaceData.roles[role].invokeOutputs"\n                        v-bind:icon="interfaceData.roles[role].icon"\n                        v-bind:title="interfaceData.roles[role].name"\n                        v-bind:devs="devs"\n                        v-bind:role_id="role"\n                        v-bind:status="states_clean(role)">\n                    </shif-ctrl-summary>\n                </template>\n                <template v-else>\n                    {{ log("This role is not defined: " + role) }}\n                </template>\n            </template>\n        </div>\n    '
};

var app = new Vue({
    el: '#inhalt',

    components: {
        ShifAllDevices: ShifAllDevices
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// Icon anzeigen
////////////////////////////////////////////////////////////////////////////////////////////////////////
function showIcon(icon) {
    if (icon in icons) {
        return '<div class="svg_icon ' + icon + '">' + icons[icon] + '</div>';
    } else if (icon in interfaceData.iconFallback) {
        return '<div class="svg_icon ' + interfaceData.iconFallback[icon] + '">' + icons[interfaceData.iconFallback[icon]] + '</div>';
    } else {
        console.warn('Icon is missing: ' + icon);
        return '<div class="svg_icon icon_default">\n            <svg xmlns="http://www.w3.org/2000/svg" version="1.1" x="0" y="0" width="500" height="500" viewBox="0 0 500 500">\n                <path d="M227.52 320.99L227.52 301.54Q227.52 289.25 229.31 279.52 231.1 269.79 234.94 261.09 238.78 252.38 245.18 244.19 251.58 236 261.31 226.78L284.35 204.77Q294.08 196.06 300.99 185.31 307.9 174.56 307.9 159.2 307.9 139.23 295.36 125.66 282.82 112.1 259.78 112.1 248 112.1 238.53 116.45 229.06 120.8 222.14 128.22 215.23 135.65 211.65 145.38 208.06 155.1 207.55 165.34L144.58 159.71Q147.65 135.14 157.63 115.94 167.62 96.74 183.49 83.42 199.36 70.11 219.84 63.2 240.32 56.29 263.87 56.29 285.89 56.29 305.6 62.69 325.31 69.09 340.42 81.63 355.52 94.18 364.22 112.61 372.93 131.04 372.93 155.1 372.93 171.49 369.34 183.78 365.76 196.06 359.1 206.3 352.45 216.54 342.98 226.02 333.5 235.49 321.73 245.73 311.49 254.43 305.09 261.09 298.69 267.74 294.85 274.4 291.01 281.06 289.47 288.74 287.94 296.42 287.94 307.68L287.94 320.99zM217.28 392.16Q217.28 375.78 229.31 364 241.34 352.22 258.24 352.22 274.62 352.22 286.91 363.49 299.2 374.75 299.2 391.14 299.2 407.52 287.17 419.3 275.14 431.07 258.24 431.07 250.05 431.07 242.62 428 235.2 424.93 229.57 419.81 223.94 414.69 220.61 407.52 217.28 400.35 217.28 392.16z"/>\n            </svg>\n      </div>';
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var lighting_switch_l2 = clone(shif_device);
lighting_switch_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
lighting_switch_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change($event, true)"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var lighting_switch_l3 = clone(shif_device);
lighting_switch_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
lighting_switch_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal()"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('lightingSwitch', lighting_switch_l2, lighting_switch_l3);

var lighting_brightness = clone(shif_device);
lighting_brightness.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
lighting_brightness.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="props.maximumScaled"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-bind:step=5\n                 v-on:change="change"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('lightingBrightness', lighting_switch_l2, lighting_brightness);

var lighting_button_l2 = clone(shif_device);
lighting_button_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var lighting_button_l3 = clone(shif_device);
lighting_button_l3.methods.change = function (event, down) {
    homegear.value_set_clickcounter(this, this.output, down);
};
lighting_button_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place"\n                     v-on:mousedown="change($event, true)"\n                     v-on:mouseup="change($event, false)">\n    </shif-generic-l2>\n';

shif_comps_create('lightingButton', lighting_button_l2, lighting_button_l3);
shif_comps_create('refresh', lighting_button_l2, lighting_button_l3);

var lighting_color_l2 = clone(shif_device);
lighting_color_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var lighting_color_l3 = clone(shif_device);
lighting_color_l3.methods.change = function (event) {
    this.props.value = event.color.hexString;
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
lighting_color_l3.template = '\n    <shif-colorpicker v-bind:width="500"\n                      v-bind:height="520"\n                      v-bind:color="props.value"\n                      v-on:input:end="change" />\n';

shif_comps_create('lightingColor', lighting_color_l2, lighting_color_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
$(document).ready(function () {
    var mainmenuItemWidth = 100 / Object.keys(interfaceData.mainmenu).length;
    var mainmenuItem = '';

    $.each(interfaceData.mainmenu, function (key, value) {
        var active = value.name === interfaceData.options.firstBreadcrumbId ? 'active' : '';

        if (value.name == 'house') {
            value.onclickOptions.name = interfaceData.options.firstBreadcrumb;
        } else {
            value.onclickOptions.name = i18n(value.name);
        }

        mainmenuItem += '\n            <li style="width: ' + mainmenuItemWidth + '%;" onclick=\'' + value.onclick + '(' + JSON.stringify(value.onclickOptions) + ');\'>\n                <div id="mainmenu_' + value.name + '" class="mainmenu_button ' + active + '">' + showIcon(value.icon) + '</div>\n            </li>\n        ';
    });

    $('#inhalt').after('\n        <div id="mainmenu">\n            <ul class="menu">\n                ' + mainmenuItem + '\n            </ul>\n        </div>\n    ');

    if (interfaceData.options.firstBreadcrumbId == 'house') {
        $('#house_rooms').html(house_level1_content);
        house_level1_fix();
    } else if (interfaceData.options.firstBreadcrumbId == 'widgets') {
        main({
            name: 'Widgets',
            content: 'widgets',
            menu: 'widgets'
        });
    }
});

////////////////////////////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////////////////////////////
function main(options) {

    for (var i = 1; i < interfaceData.options.breadcrumbs_id_array.length; i++) {
        $('#' + interfaceData.options.breadcrumbs_id_array[i]).remove();
    }interfaceData.options.breadcrumbs_id_array = [options.content];

    $('.content_single').removeClass('content_single');
    $('.content_small').removeClass('content_small');
    $('.content_big').removeClass('content_big');
    $('.content_back').remove();

    $('.mainmenu_button').removeClass('active');
    $('#mainmenu_' + options.content).addClass('active');

    $('#back').addClass('inactive');

    if ('menu' in options) {
        $('#' + options.content).html(menu({
            mainmenu: options.menu,
            level: '1'
        }));
    }

    $('#' + options.content).addClass('content_single');
    $('.content').scrollTop(0);

    interfaceData.options.breadcrumbs_array = ['\n        <div class="breadcrumbsJump" onclick=\'main({"name":"' + options.name + '","content":"' + options.content + '"});\'>\n            ' + options.name + '\n        </div>\n    '];

    var text = '';
    for (var _i5 = 0; _i5 < interfaceData.options.breadcrumbs_array.length; _i5++) {
        text += interfaceData.options.breadcrumbs_array[_i5];

        if (_i5 + 1 != interfaceData.options.breadcrumbs_array.length) text += '<div class="breadcrumbs_separator">|</div>';
    }

    document.getElementById('breadcrumbsSub').innerHTML = text;

    $('#breadcrumbsSub').scrollLeft(9999999999);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function menu(options) {
    var menu = '';

    $.each(interfaceData.menu, function (key, value) {
        if (options.mainmenu !== value.mainmenu || options.level !== value.level) return;

        if ('category' in options && options.category !== value.category) return;

        value.onclickOptions.name = i18n(value.name);
        var name = i18n(value.name);
        var description = i18n(value.description);

        menu += '\n            <div class="button" onclick=\'' + value.onclick + '(' + JSON.stringify(value.onclickOptions) + ')\'>\n                <div class="button_icon">\n                    ' + showIcon(value.icon) + '\n                </div>\n                <div class="button_text">\n                    <div class="button_title">' + name + '</div>\n                    <br/>\n                    <div class="button_status">' + description + '</div>\n                </div>\n                <div class="button_action">\n                    <svg xmlns="http://www.w3.org/2000/svg" version="1.1" id="svg" x="0" y="0" width="370.81" height="370.81" viewBox="0 0 370.81 370.81">\n                        <g id="Ebene_1">\n                            <path d="M77.9 345.97L102.03 370.81 292.92 185.41 102.03 0 77.9 24.85 243.18 185.41z"/>\n                        </g>\n                    </svg>\n                </div>\n            </div>\n        ';
    });

    if ('content' in options && options.content === 'true') {
        content('this', {
            content: menu,
            name: options.name
        });
    } else return menu;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var socket_switch_l2 = clone(shif_device);
socket_switch_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
socket_switch_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var socket_switch_l3 = clone(shif_device);
socket_switch_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
socket_switch_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:place="place"\n                     v-bind:status="status_minimal()"\n                     v-on:click="change">\n    </shif-generic-l2>\n';

shif_comps_create('socketSwitch', socket_switch_l2, socket_switch_l3);

var socket_button_l2 = clone(shif_device);
socket_button_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var socket_button_l3 = clone(shif_device);
socket_button_l3.methods.change = function (event, down) {
    homegear.value_set_clickcounter(this, this.output, down);
};
socket_button_l3.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place"\n                     v-on:mousedown="change($event, true)"\n                     v-on:mouseup="change($event, false)">\n    </shif-generic-l2>\n';

shif_comps_create('socketButton', socket_button_l2, socket_button_l3);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
function status_format(status, precision) {
    var _this5 = this;

    if (typeof status === 'string') {
        var regex = /^(\d+(?:\.\d+)?)/;
        return status.replace(regex, function (match) {
            return _this5.float_formatted(match, precision);
        });
    }

    var _iteratorNormalCompletion13 = true;
    var _didIteratorError13 = false;
    var _iteratorError13 = undefined;

    try {
        for (var _iterator13 = status[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
            var cur = _step13.value;

            cur.value = status_format.apply(this, [cur.value, precision]);
        }
    } catch (err) {
        _didIteratorError13 = true;
        _iteratorError13 = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion13 && _iterator13.return) {
                _iterator13.return();
            }
        } finally {
            if (_didIteratorError13) {
                throw _iteratorError13;
            }
        }
    }

    return status;
}

var climate_main = clone(shif_device);
climate_main.computed.status_formatted = function () {
    return status_format.apply(this, [this.status_minimal(false), 1]);
};
climate_main.computed.icon = function () {
    return 'main' in this.icons ? this.icons.main : this.control.icons.main;
};
climate_main.template = '\n    <shif-generic-l2 v-bind:icon="icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: icon.color, text: texts.title.color}"\n                     v-bind:status="status_formatted"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

var openweathermap_l2 = clone(shif_device);
openweathermap_l2.computed.status_formatted = function () {
    return status_format.apply(this, [this.status, 1]);
};
openweathermap_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.weather.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.weather.color, text: texts.title.color}"\n                     v-bind:status="status_formatted"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

shif_comps_create('humidity', openweathermap_l2, climate_main);
shif_comps_create('temperature', openweathermap_l2, climate_main);
shif_comps_create('climateCity', openweathermap_l2, climate_main);
shif_comps_create('climateCloudcoverage', openweathermap_l2, climate_main);
shif_comps_create('climateDate', openweathermap_l2, climate_main);
shif_comps_create('climatePressure', openweathermap_l2, climate_main);
shif_comps_create('climateRain3h', openweathermap_l2, climate_main);
shif_comps_create('climateSnow3h', openweathermap_l2, climate_main);
shif_comps_create('climateSunrise', openweathermap_l2, climate_main);
shif_comps_create('climateSunset', openweathermap_l2, climate_main);
shif_comps_create('climateWeather', openweathermap_l2, climate_main);
shif_comps_create('climateWinddirection', openweathermap_l2, climate_main);
shif_comps_create('climateWindgust', openweathermap_l2, climate_main);
shif_comps_create('climateWindspeed', openweathermap_l2, climate_main);
// shif_comps_create('OpenWeatherMap',    openweathermap_l2, openweathermap_l2);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var heating_slider_l2 = clone(shif_device);
heating_slider_l2.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, !this.props.value);
};
heating_slider_l2.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-on:click_icon="change"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var heating_slider_l3 = clone(shif_device);
heating_slider_l3.methods.change = function (event) {
    homegear.value_set_clickcounter(this, this.output, this.props.value);
};
heating_slider_l3.template = '\n    <shif-slider v-bind:min="props.minimumScaled"\n                 v-bind:max="parseFloat(props.maximumScaled)"\n                 v-bind:unit="props.unit"\n                 v-bind:value="props.value"\n                 v-bind:title="title"\n                 v-bind:step="0.5"\n                 v-bind:precision="1"\n                 v-on:change="change"\n                 v-bind:disabled="disabled"\n                 v-model:value="props.value">\n    </shif-slider>\n';

shif_comps_create('heatingSlider', heating_slider_l2, heating_slider_l3);

var heating_is_state_l2 = clone(shif_device);
heating_is_state_l2.template = '\n    <shif-generic-l2 v-bind:icon="control.icons.temperature.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: control.icons.temperature.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:actions="true"\n                     v-bind:place="place"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';
var heating_is_state_l3 = clone(shif_device);
heating_is_state_l3.template = '\n    <shif-generic-l2 v-bind:icon="control.icons.temperature.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: control.icons.temperature.color, text: texts.title.color}"\n                     v-bind:status="status"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('heatingIsState', heating_is_state_l2, heating_is_state_l3);

var heating_mode_l3 = clone(shif_device);
heating_mode_l3.computed.values = function () {
    var _this6 = this;

    return this.rendering.map(function (x) {
        return {
            name: x.definitions.texts.state.content,
            value: x.condition.value,
            selected: x.condition.value == _this6.props.value
        };
    });
};
heating_mode_l3.methods.change = function (x) {
    homegear.value_set_clickcounter(this, this.output, x);
};
heating_mode_l3.template = '\n    <shif-radio v-bind:title="title"\n                v-bind:values="values"\n                v-bind:disabled="disabled"\n                v-on:input="x => change(parseInt(x))">\n    </shif-radio>\n';

shif_comps_create('heatingMode', heating_is_state_l2, heating_mode_l3);

var heating_window = clone(shif_device);
heating_window.template = '\n    <shif-generic-l2 v-bind:icon="cond.icon.name"\n                     v-bind:title="title"\n                     v-bind:active="{icon: cond.icon.color, text: cond.text.color}"\n                     v-bind:status="status_minimal()"\n                     v-bind:place="place">\n    </shif-generic-l2>\n';

shif_comps_create('heatingWindow', heating_window, heating_window);

////////////////////////////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////////////////////////////
var ventilation_mode_l2 = clone(shif_device);
ventilation_mode_l2.template = '\n    <shif-generic-l2 v-bind:icon="icons.l2.name"\n                     v-bind:title="dev.label"\n                     v-bind:active="{icon: icons.l2.color, text: texts.title.color}"\n                     v-bind:place="place"\n                     v-bind:actions="true"\n                     v-bind:status="status"\n                     v-on:click="level3(device, breadcrumb)">\n    </shif-generic-l2>\n';

var ventilation_mode_l3 = clone(shif_device);
ventilation_mode_l3.methods.change = function (x) {
    homegear.value_set_clickcounter(this, this.output, x);
};
ventilation_mode_l3.computed.values = function () {
    var _this7 = this;

    return this.rendering.map(function (x) {
        return {
            name: x.definitions.texts.state.content,
            value: x.condition.value,
            selected: x.condition.value == _this7.props.value
        };
    });
};
ventilation_mode_l3.template = '\n    <shif-radio v-bind:title="title"\n                v-bind:values="values"\n                v-on:input="x => change(parseInt(x))">\n    </shif-radio>\n';

shif_comps_create('ventilationMode', ventilation_mode_l2, ventilation_mode_l3);
